#include <hmg.ch>

// Funcion GS1 () -> Devuelve un Array con el/los nombre/s del/los pais/es al/los que corresponde el
// codigo GS1 ingresado como parametro.
// Recibe un parametro Numerico o Character de 3 digitos.
// Devuelve un Array de 3 (Tres) Items (Paises).
// Creada por Claudio Ricardo Folgn --- Diciembre 2020

Function GS1 (par)

LOCAL aRes [3]

	If Len (par) <> 3

		aRes := {"Error","",""}
		Return aRes
		
	EndIf
	
	If ValType (par) = "C"
	
		par := Val (par)
		
	EndIf
	
	DO Case

		Case par < 20
			aRes := {"Estados Unidos","",""}
		Case par > 29 .AND. par < 40
			aRes := {"Estados Unidos","",""}
		Case par > 59 .AND. par < 140
			aRes := {"Estados Unidos","",""}
		Case par > 299 .AND. par < 380
			aRes := {"Francia","Monaco",""}
		Case par == 380
			aRes := {"Bulgaria","",""}
		Case par == 383
			aRes := {"Eslovenia","",""}
		Case par == 385
			aRes := {"Croacia","",""}
		Case par == 387
			aRes := {"Bosnia y Herzegovina","",""}
		Case par == 389
			aRes := {"Montenegro","",""}
		Case par == 390
			aRes := {"Kosovo","",""}
		Case par > 399 .AND. par < 441
			aRes := {"Alemania","",""}
		Case par > 449 .AND. par < 460
			aRes := {"Japon","",""}
		Case par > 459 .AND. par < 470
			aRes := {"Federacion Rusa","",""}
		Case par == 470
			aRes := {"Kirguistan","",""}
		Case par == 471
			aRes := {"Taiwan","",""}
		Case par == 474
			aRes := {"Estonia","",""}
		Case par == 475
			aRes := {"Letonia","",""}
		Case par == 476
			aRes := {"Azerbaiyan","",""}
		Case par == 477
			aRes := {"Lituania","",""}
		Case par == 478
			aRes := {"Uzbekistan","",""}
		Case par == 479
			aRes := {"Sri Lanka","",""}
		Case par == 480
			aRes := {"Filipinas","",""}
		Case par == 481
			aRes := {"Bielorrusia","",""}
		Case par == 482
			aRes := {"Ucrania","",""}
		Case par == 483
			aRes := {"Turkmenistan","",""}
		Case par == 484
			aRes := {"Moldavia","",""}
		Case par == 485
			aRes := {"Armenia","",""}
		Case par == 486
			aRes := {"Georgia","",""}
		Case par == 487
			aRes := {"Kazajistan","",""}
		Case par == 488
			aRes := {"Tayikistan","",""}
		Case par == 489
			aRes := {"Hong Kong","",""}
		Case par > 489 .AND. par < 500
			aRes := {"Japon","",""}
		Case par > 499 .AND. par < 510
			aRes := {"Reino Unido","",""}
		Case par == 520 .OR. par == 521
			aRes := {"Grecia","",""}
		Case par == 528
			aRes := {"Libano","",""}
		Case par == 529
			aRes := {"Chipre","",""}
		Case par == 530
			aRes := {"Albania","",""}
		Case par == 531
			aRes := {"Macedonia","",""}					// Macedonia del Norte
		Case par == 535
			aRes := {"Malta","",""}
		Case par == 539
			aRes := {"Irlanda","",""}
		Case par > 539 .AND. par < 550
			aRes := {"Belgica","Luxemburgo",""}
		Case par == 560
			aRes := {"Portugal","",""}
		Case par == 569
			aRes := {"Islandia","",""}
		Case par > 569 .AND. par < 580
			aRes := {"Dinamarca","Islas Feroe","Groenlandia"}
		Case par == 590
			aRes := {"Polonia","",""}
		Case par == 594
			aRes := {"Rumania","",""}
		Case par == 599
			aRes := {"Hungria","",""}
		Case par == 600 .OR. par == 601
			aRes := {"Sudafrica","",""}
		Case par == 603
			aRes := {"Ghana","",""}
		Case par == 604
			aRes := {"Senegal","",""}
		Case par == 608
			aRes := {"Bahrein","",""}
		Case par == 609
			aRes := {"Mauricio","",""}
		Case par == 611
			aRes := {"Marruecos","",""}
		Case par == 613
			aRes := {"Argelia","",""}
		Case par == 615
			aRes := {"Nigeria","",""}
		Case par == 616
			aRes := {"Kenia","",""}
		Case par == 617
			aRes := {"Camerun","",""}
		Case par == 618
			aRes := {"Costa De Marfil","",""}
		Case par == 619
			aRes := {"Tunez","",""}
		Case par == 620
			aRes := {"Tanzania","",""}
		Case par == 621
			aRes := {"Siria","",""}
		Case par == 622
			aRes := {"Egipto","",""}
		Case par == 623
			aRes := {"Brunei","",""}
		Case par == 624
			aRes := {"Libia","",""}
		Case par == 625
			aRes := {"Jordania","",""}
		Case par == 626
			aRes := {"Iran","",""}
		Case par == 627
			aRes := {"Kuwait","",""}
		Case par == 628
			aRes := {"Arabia Saudita","",""}
		Case par == 629
			aRes := {"Emiratos Arabes Unidos","",""}
		Case par == 630
			aRes := {"Catar","",""}
		Case par > 639 .AND. par < 650
			aRes := {"Finlandia","",""}
		Case par > 689 .AND. par < 700
			aRes := {"China","",""}
		Case par > 699 .AND. par < 710
			aRes := {"Noruega","",""}
		Case par == 729
			aRes := {"Israel","",""}
		Case par > 729 .AND. par < 740
			aRes := {"Suecia","",""}
		Case par == 740
			aRes := {"Guatemala","",""}
		Case par == 741
			aRes := {"El Salvador","",""}
		Case par == 742
			aRes := {"Honduras","",""}
		Case par == 743
			aRes := {"Nicaragua","",""}
		Case par == 744
			aRes := {"Costa Rica","",""}
		Case par == 745
			aRes := {"Panama","",""}
		Case par == 746
			aRes := {"Republica Dominicana","",""}
		Case par == 750
			aRes := {"Mexico","",""}
		Case par == 754 .OR. par == 755
			aRes := {"Canada","",""}
		Case par == 759
			aRes := {"Venezuela","",""}
		Case par > 759 .AND. par < 770
			aRes := {"Suiza","Liechtenstein",""}
		Case par == 770 .OR. par == 771
			aRes := {"Colombia","",""}
		Case par == 773
			aRes := {"Uruguay","",""}
		Case par == 775
			aRes := {"Peru","",""}
		Case par == 777
			aRes := {"Bolivia","",""}
		Case par == 778 .OR. par == 779
			aRes := {"Argentina","",""}
		Case par == 780
			aRes := {"Chile","",""}
		Case par == 784
			aRes := {"Paraguay","",""}
		Case par == 786
			aRes := {"Ecuador","",""}
		Case par == 789 .OR. par == 790
			aRes := {"Brasil","",""}
		Case par > 799 .AND. par < 840
			aRes := {"Italia","San Marino","Ciudad Del Vaticano"}
		Case par > 839 .AND. par < 850
			aRes := {"Espaa","Andorra",""}
		Case par == 850
			aRes := {"Cuba","",""}
		Case par == 858
			aRes := {"Eslovaquia","",""}
		Case par == 859
			aRes := {"Republica Checa","",""}
		Case par == 860
			aRes := {"Serbia","",""}
		Case par == 865
			aRes := {"Mongolia","",""}
		Case par == 867
			aRes := {"Corea Del Norte","",""}
		Case par == 868 .OR. par == 869
			aRes := {"Turquia","",""}
		Case par > 869 .AND. par < 880
			aRes := {"Paises Bajos","",""}
		Case par == 880
			aRes := {"Corea Del Sur","",""}
		Case par == 883
			aRes := {"Myanmar","",""}
		Case par == 884
			aRes := {"Camboya","",""}
		Case par == 885
			aRes := {"Tailandia","",""}
		Case par == 888
			aRes := {"Singapur","",""}
		Case par == 890
			aRes := {"India","",""}
		Case par == 893
			aRes := {"Vietnam","",""}
		Case par == 896
			aRes := {"Pakistan","",""}
		Case par == 899
			aRes := {"Indonesia","",""}
		Case par > 899 .AND. par < 920
			aRes := {"Austria","",""}
		Case par > 929 .AND. par < 940
			aRes := {"Australia","",""}
		Case par > 939 .AND. par < 950
			aRes := {"Nueva Zelanda","",""}

		Case par == 950
			aRes := {"Head Office","",""}

		Case par == 955
			aRes := {"Malasia","",""}
		Case par == 958
			aRes := {"Macao","",""}

		Case par == 977
			aRes := {"Publicaciones Seriales (ISSN)","",""}
		Case par == 978 .OR. par == 979
			aRes := {"Libros (ISBN)","",""}
		Case par == 980
			aRes := {"Recibos de devolucion","",""}
		Case par == 977
			aRes := {"Publicaciones Seriales (ISSN)","",""}
		Case par == 981 .OR. par == 982
			aRes := {"Cupones","",""}
		Case par > 989 .AND. par < 1000
			aRes := {"Cupones","",""}

		OtherWise
			aRes := {"Desconocido o de uso Privado","",""}
			
	EndCase

Return aRes
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion EanCheck ---> Verifica en un codigo EAN-8 o EAN-13 si el Checksum es correcto (devuelve .T.)
// Recibe Character o Numeric y Retorna Logico
// Precisa la funcion EanCheckSum ()
// Creado por Claudio Ricardo Folgn --- Diciembre 2020

Function EanCheck (cCode)

LOCAL lRetu, cDigit, cCheck

	If ValType (cCode) = "N"
	
		cCode := AllTrim ( Str (cCode))
		
	EndIf

	If Len (cCode) == 8 .OR. Len (cCode) == 13

		cDigit := SubStr (cCode, - 1, 1)
		cCheck := EanCheckSum (SubStr (cCode, 1, Len (cCode) - 1))

		Iif (cDigit == cCheck, lRetu := .T. , lRetu := .F.)

	Else

		lRetu := .F.
		
	EndIf

Return lRetu
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Genera el digito verificador acorde al standard EAN (Checksum) del codigo ingresado
// Recibe Character o Numeric y Retorna 1 digito Character
// Creado por Claudio Ricardo Folgn --- Diciembre 2020

Function EanCheckSum (cCode)

LOCAL nSuma, nDigit, i
   
	If ValType (cCode) = "N"
	
		cCode := AllTrim ( Str (cCode))
		
	EndIf

	nSuma := 0
   
	For i = Len (cCode) To 1 Step - 1
		
		nDigit = Val (SubStr (cCode, i, 1))

		If (Mod (Len (cCode) - i + 1, 2)) <> 0

			nSuma = nSuma + (nDigit * 3)

		Else

			nSuma = nSuma + nDigit
			
		EndIf

	Next

Return Str (Mod (10 - Mod (nSuma, 10), 10),1,0)
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
