// Funcion Codigos GS1 --> Verifica longitud del codigo ingresado manualmente o mediante
// Scanner y muestra: Tipo de Codigo, CheckSum y Pais emisor con su bandera.
// Si se ingresan slo los 3 primeros digitos muestra slo el pas emisor.
// Creado por Claudio Ricardo Folgn //  Diciembre del 2020
// Compilado con HMG 3.4.4 ANSI (Porque el resto del programa lo hice en ANSI)

#include <hmg.ch>

Function Main_Button_GS1_Action

	If IsWindowActive ( GS1 )

		DoMethod ("GS1" , " SetFocus ")
		
	Else
	
		Load Window GS1
		
		GS1. Center
		GS1. Activate
		
	EndIf

Return Nil
//------------------------------------------------------------------------------------------------------//

Function GS1_Button_Scan_Action

	GS1_Limpia ()
	
	DoMethod ("GS1" , "Text_In" , " SetFocus ")

Return Nil
//------------------------------------------------------------------------------------------------------//

Function GS1_Limpia							// Para un nuevo escaneo o ingreso manual

	SetProperty ("GS1" , "Text_In" , " Value " , "")

	SetProperty ("GS1" , "Label_Tipo" , " Value " , "")
	
		SetProperty ("GS1" , "Image_1" , " Picture " , "WhiteFlag")
		SetProperty ("GS1" , "Label_1" , " Value " , "")

		SetProperty ("GS1" , "Image_2" , " Picture " , "WhiteFlag")
		SetProperty ("GS1" , "Label_2" , " Value " , "")

		SetProperty ("GS1" , "Image_3" , " Picture " , "WhiteFlag")
		SetProperty ("GS1" , "Label_3" , " Value " , "")

Return Nil
//------------------------------------------------------------------------------------------------------//

Function GS1_Button_Buscar_Action

LOCAL cCodigo := AllTrim ( GetProperty ("GS1" , "Text_In" , " Value "))
LOCAL nLong := Len (cCodigo)
LOCAL cTipo := ""
LOCAL aPais := {}
LOCAL lFlags := .F.
LOCAL lCheck := .T.

	DO Case
	
		Case nLong == 3
		
			cTipo := "Slo Pas emisor"
			lFlags := .T.
			lCheck := .F.
			
		Case nLong == 6
	
			cTipo := "UPC - E"
			lCheck := .F.

		Case nLong == 8
	
			cTipo := "EAN - 8"
			lFlags := .T.
			
		Case nLong == 12

			cTipo := "UPC - A"
			cCodigo := AllTrim ("0" + cCodigo)					// Convertirlo en EAN - 13

		Case nLong == 13
		
			cTipo := "EAN - 13"
			lFlags := .T.
	
		OtherWise
		
			cTipo := "Cdigo incompleto o desconocido"
			lCheck := .F.

	EndCase

	If lCheck
	
		cTipo = cTipo + "  -  " + Iif (EanCheck (cCodigo),"CheckSum Correcto !","Error de CheckSum !")

	EndIf
	
	SetProperty ("GS1" , "Label_Tipo" , " Value " , cTipo)

	If lFlags

		aPais := GS1 (SubStr (cCodigo,1,3))						// Envio a GS1 () los 3 primeros digitos

																// Esto es porque el archivo .rc da error
																// con espacios o caracteres especiales
																// y en [1] est Espaa
																
		SetProperty ("GS1" , "Image_1" , " Picture " , StrTran ( StrTran (aPais [1],"","n")," ","_"))
		SetProperty ("GS1" , "Label_1" , " Value " , aPais [1])

		SetProperty ("GS1" , "Image_2" , " Picture " , StrTran (aPais [2]," ","_"))
		SetProperty ("GS1" , "Label_2" , " Value " , aPais [2])

		SetProperty ("GS1" , "Image_3" , " Picture " , StrTran (aPais [3]," ","_"))
		SetProperty ("GS1" , "Label_3" , " Value " , aPais [3])

	EndIf
	
Return Nil
//------------------------------------------------------------------------------------------------------//